<%@ page import="java.util.*, com.hlcl.rql.as.*, com.hlcl.rql.util.as.*" session="false" isThreadSafe="true" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<%
// get variables
ResourceBundle b = ResourceBundle.getBundle("com.hlcl.rql.as.rql_fw");
String cssUrl = b.getString("cssUrl");
%>
<%-- remove server name when migrating to DEVE or PROD --%>
<link href="<%=cssUrl%>" rel="styleSheet" type="text/css">
<TITLE>Show child details</TITLE>
</HEAD>

<BODY>
<%
// get all RedDot session/project values from request
String logonGuid = request.getParameter("logonGuid");
String sessionKey = request.getParameter("sessionKey");
String projectGuid = request.getParameter("projectGuid");
String linkGuid = request.getParameter("linkGuid");
//or
String pageGuid = request.getParameter("pageGuid");
String linkName = request.getParameter("linkName");

// constants
String mappingPageId = "197347";

try {
	CmsClient client = new CmsClient(logonGuid);
	Project project = client.getProject(sessionKey, projectGuid);

	// prepare source link details
	Page linkPg = null;
	MultiLink sourceLink = null;
	if (linkGuid == null) {
		linkPg = project.getPageByGuid(pageGuid);
		sourceLink = linkPg.getMultiLink(linkName);
		// link name given as parm!
	} else {
		sourceLink = project.getMultiLinkByGuid(linkGuid);
		linkPg = sourceLink.getPage();
		linkName = sourceLink.getName();
	}
%>	

<!-- page title, mandatory -->
<div class="block">
<table class="pageTitleTable" cellspacing="0" cellpadding="0">
    <tr>
        <td class="pageTitleGrey">Show child details</td>
    </tr>
</table>
</div>

<div class="block">
<p>See details of all children of following MultiLink:<br>
<strong><%=linkPg.getInfoText("&nbsp;")%></strong><br>
<%
	Page mappingsPg = project.getPageById(mappingPageId);
	if(mappingsPg != null) {
		ScriptParameters mappings = new ScriptParameters(mappingsPg);
		String mappedName = mappings.get(linkName);
		if (mappedName != null) {
%>
<span class="rdSEComment"><%=mappedName%></span>
<img src="images/reddotmultilink.gif" border="0" title="<%=linkName%>"/>
<%
		} else {
%>
<strong>&nbsp;&nbsp;<%=linkName%></strong>			
<%		
		}
	} else {
%>
<strong>&nbsp;&nbsp;<%=linkName%></strong>			
<%		
	} // end if mappings vorhanden
%>
</P>
</div>

<!-- result or exception block -->
<div class="block">
<div id="working">
Collecting child details...<br />
</div>

<div class="block" id="ready" style="display=none">
<p>You can show the workflow comment, if it is available. Use the link in column State.</p>
<table class="listTable" style="border-collapse:collapse" cellspacing="0" cellpadding="3">
<thead>
<tr>
 <th class="listHead" style="width:5%; text-align:left;">ID</th>  
 <th class="listHead" style="width:25%; text-align:left;">Headline</th>  
 <th class="listHead" style="width:10%; text-align:left;">Content class</th>  
 <th class="listHead" style="width:10%; text-align:left;">Created by</th>  
 <th class="listHead" style="width:10%; text-align:left;">Created on</th>  
 <th class="listHead" style="width:10%; text-align:left;">Last<br>changed by</th>  
 <th class="listHead" style="width:10%; text-align:left;">Last<br>changed on</th>  
 <th class="listHead" style="width:10%; text-align:left;">State</th>  
 <th class="listHead" style="width:10%; text-align:left;">Released on</th>  
</tr>
</thead>
<tbody>
<%
	out.flush();
	// for all childs do
	int total = 0;
	PageArrayList childs = sourceLink.getChildPages();
	for (int k = 0; k < childs.size(); k++) {
		Page child = childs.getPage(k);
		total++;
		// gather child details
		String pageInfo = child.getInfoText();
		User createdBy = child.getCreatedByUser();
		String createdByStr = child.hasCreatedUser() ? child.getCreatedByUserName() : StringHelper.buildHtmlMailto(createdBy.getEmailAddress(), pageInfo, createdBy.getName());
		String createdOn = child.getCreatedOn().getAsddMMyyyy();
		User changedBy = child.getLastChangedByUser();
		String changedOn = child.getLastChangedOn().getAsddMMyyyy();
		String releasedOn = "";
		ReddotDate released = child.getReleasedOn();
		if (released != null) {
			releasedOn = released.getAsddMMyyyy();
		}
		// get note, no note link, if not hip project
		String noteName = child.getTemplateName() + " comment";
		String noteValue = "";
		if (child.hasNote(noteName)) {
			noteValue = child.getNote(noteName).getEnteredText().trim();
		}
%>
<tr>
 <td class="borderedTextRow" style="font-size:100%;"><%=child.getPageId()%></td>
 <td class="borderedTextRow" style="font-size:100%;"><%=child.getHeadline()%></td>
 <td class="borderedTextRow" style="font-size:100%;"><%=child.getTemplateName()%></td>
 <td class="borderedTextRow" style="font-size:100%;"><%=createdByStr%></td>
 <td class="borderedTextRow" style="font-size:100%;"><%=createdOn%></td>
 <td class="borderedTextRow" style="font-size:100%;"><%=StringHelper.buildHtmlMailto(changedBy.getEmailAddress(), pageInfo, changedBy.getName())%></td>
 <td class="borderedTextRow" style="font-size:100%;"><%=changedOn%></td>
 <td class="borderedTextRow" style="font-size:100%;">
<%
String stateInfo = child.getStateInfo();
if (noteValue.length() == 0) {
	// no note, no link
	out.println(stateInfo);
} else {
%>
 <a target="_blank" href="showNotes.jsp?logonGuid=<%=logonGuid%>&sessionKey=<%=sessionKey%>&projectGuid=<%=projectGuid%>&pageGuid=<%=child.getPageGuid()%>"><%=stateInfo%></a>
<%	
} // end if note value 
%>
 </td>
 <td class="borderedTextRow" style="font-size:100%;"><%=releasedOn%></td>
</tr>
<%
	} // end for all childs
%>
</tbody>
</table>
<script language=javascript>
	document.getElementById("working").style.display="none";
	document.getElementById("ready").style.display="block";
	window.scrollTo(0,0);
</script>
<br>
<p><%=total%> child pages found.</p>
<h2>Show child details ends successfully.</h2>
<%
} catch (RQLException ex) {
	out.println("<h2>Error occurred</h2>");
	out.print(ex.getMessage());
	System.err.println(ex.getMessage());
	ex.printStackTrace();
	if (ex.getReason() != null) {
		out.print(ex.getReason().getMessage());
		System.err.println(ex.getReason().getMessage());
		ex.getReason().printStackTrace();
	}
}
%>
<form>
<input type="button" value="Close window" onClick="javascript:window.close()">&nbsp;
</form>
</div>

</BODY>
</HTML>
