<%@ page import="java.util.*, com.hlcl.rql.as.*" session="false" isThreadSafe="true" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<%
// get CPS prefix
ResourceBundle b = ResourceBundle.getBundle("com.hlcl.rql.as.rql_fw");
String cssUrl = b.getString("cssUrl");
%>
<%-- remove server name when migrating to DEVE or PROD --%>
<link href="<%=cssUrl%>" rel="styleSheet" type="text/css">
<TITLE>Show template elements usage</TITLE>
<script type="text/javascript">
<!--
function trim(s) {
  while (s.substring(0,1) == ' ') {
    s = s.substring(1,s.length);
  }
  while (s.substring(s.length-1,s.length) == ' ') {
    s = s.substring(0,s.length-1);
  }
  return s;
}
function checkForm() {
  document.inputForm.btnSubmit.disabled = true;
  document.inputForm.btnClose.disabled = true;
  return true;
}
//-->
</script>
</HEAD>

<BODY>
<%
// get all RedDot session/project values from request
String logonGuid = request.getParameter("logonGuid");
String sessionKey = request.getParameter("sessionKey");
String projectGuid = request.getParameter("projectGuid");
String templateGuid = request.getParameter("templateGuid");
%>	

<!-- page title, mandatory -->
<div class="block">
<table class="pageTitleTable" cellspacing="0" cellpadding="0">
    <tr>
        <td class="pageTitleGrey">Show template elements usage</td>
    </tr>
</table>
</div>

<!-- formular block -->
<%
try {
	// open project
	CmsClient client = new CmsClient(logonGuid);
	Project project = client.getProject(sessionKey, projectGuid);
	Template template = project.getTemplateByGuid(templateGuid);
	
	java.util.List<TemplateVariant> variants = template.getTemplateVariants();
	java.util.List<TemplateElement> elements = template.getTemplateElements();
%>	
<div class="block">
<p>This script shows the usage of all template elements per template variant for template:<br>
<strong><%=template.getTemplateFolder().getName()%> / <%=template.getName()%></strong>
</p>
<table class="listTable" style="border-collapse:collapse" cellspacing="0" cellpadding="3">
<thead>
<tr>
 <th class="listHead" style="text-align:left;">Element name</th>  
 <th class="listHead" style="text-align:left;">Type</th>  
 <th class="listHead" style="text-align:left;">Used?</th>  
<%	
	// show column header per variant
	for (TemplateVariant variant : variants) {
%>
 <th class="listHead" style="text-align:left;"><%=variant.getName() %></th>  
<%	
	} // end for all variants
%>
</tr>
</thead>
<tbody>
<%
	for (TemplateElement element : elements) {
		String colorStyle = "";
		boolean used = template.usesTemplateElement(element); 
		if (!used) {
			colorStyle = "background-color:#FFFF99;";
		}
%>
<tr>
 <td class="borderedTextRow" style="font-size:100%;<%=colorStyle%>"><%=element.getName()%></td>
 <td class="borderedTextRow" style="font-size:100%;<%=colorStyle%>"><%=element.getTypeName()%></td>
 <td class="borderedTextRow" style="font-size:100%;<%=colorStyle%>"><%=StringHelper.convertToYesNo(used) %></td>
<%	
		// show column header per variant
		for (TemplateVariant variant : variants) {
%>
 <td class="borderedTextRow" style="font-size:100%;<%=colorStyle%>"><%=variant.usesTemplateCodeElement(element) ? "yes" : "" %></td>
<%	
		} // end for all variants
%>
</tr>
<%		
	} // end for all elements
%>
</tbody>
</table>
<br>
<%=elements.size()%> template elements checked.
<h2>Script ends successfully.</h2>
<input type="button" name="btnClose" value="Close window" onClick="window.close()">
</div>

<%
} catch (RQLException ex) {
	out.println("<h2>Error occurred</h2>");
	out.print(ex.getMessage());
	System.err.println(ex.getMessage());
	ex.printStackTrace();
	if (ex.getReason() != null) {
		out.print(ex.getReason().getMessage());
		System.err.println(ex.getReason().getMessage());
		ex.getReason().printStackTrace();
	}
}
%>
</BODY>
</HTML>
