<%@ page import="java.util.*, com.hlcl.rql.as.*" session="false" isThreadSafe="true" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<%
// get variables
ResourceBundle b = ResourceBundle.getBundle("com.hlcl.rql.as.rql_fw");
String cssUrl = b.getString("cssUrl");
%>
<%-- remove server name when migrating to DEVE or PROD --%>
<link href="<%=cssUrl%>" rel="styleSheet" type="text/css">
<TITLE>Show users of group</TITLE>
</HEAD>

<BODY>
<%
// get all RedDot session/project values from request
String logonGuid = request.getParameter("logonGuid");
String sessionKey = request.getParameter("sessionKey");
String projectGuid = request.getParameter("projectGuid");
String userGroupGuid = request.getParameter("userGroupGuid");

try {
	CmsClient client = new CmsClient(logonGuid);
	Project project = client.getProject(sessionKey, projectGuid);
	
	// get user group 
	UserGroup userGroup = null;
	try {
		userGroup = project.getUserGroupByGuid(userGroupGuid);
	} catch (ElementNotFoundException enfe) {
		// ignore, group = null indicates == Everyone
	}
%>	

<!-- page title, mandatory -->
<div class="block">
<table class="pageTitleTable" cellspacing="0" cellpadding="0">
    <tr>
        <td class="pageTitleGrey">Show users of group</td>
    </tr>
</table>
</div>

<div class="block">
<p>You selected the user group<br>
<strong><%= userGroup == null ? "Everyone" : userGroup.getName()%></strong></P>
</div>
<%
	if (userGroup == null) {
%>
<p>You selected pseudo user group Everyone. All users assigned to the current project belongs to this group.</p>
<%		
	} else { // else if userGroup == null
	// get all users of group
	int total = 0;
	java.util.List users = userGroup.getUsers();
	if (users.size() == 0 ) {
%>
<p>There are no users in this user group.</p>
<%		
	} else { // else if user size = 0 
		
%>

<!-- result or exception block -->
<div class="block">
<div id="working">
Collecting user data...<br />
</div>

<table class="listTable" style="border-collapse:collapse" cellspacing="0" cellpadding="3">
<thead>
<tr>
 <th class="listHead" style="width:10%; text-align:left;">ID</th>  
 <th class="listHead" style="width:35%; text-align:left;">Name</th>  
 <th class="listHead" style="width:20%; text-align:left;">E-mail</th>  
 <th class="listHead" style="width:35%; text-align:left;">Description</th>  
</tr>
</thead>
<tbody>
<%
	out.flush();
	// for all users of group do
	for (int k = 0; k < users.size(); k++) {
		User user = (User) users.get(k);
		total++;
		// gather child details
		String name = user.getName();
		String fullname = user.getFullname();
		String description = user.getDescription();
		String address = user.getEmailAddress();
%>
<tr>
 <td class="borderedTextRow" style="font-size:100%;"><%=name%></td>
 <td class="borderedTextRow" style="font-size:100%;"><%=fullname%></td>
 <td class="borderedTextRow" style="font-size:100%;"><a href="mailto:<%=address%>"><%=address%></a></td>
 <td class="borderedTextRow" style="font-size:100%;"><%=description%></td>
</tr>
<%
	} // end for all users
%>
</tbody>
</table>
<script language=javascript>
	document.getElementById("working").style.display="none";
	window.scrollTo(0,0);
</script>
<br>
<p><%=total%> users in user group.</p>
<%
	} // end if users size == 0 
	} // end if userGroup == null
%>
	<h2>Show users of group ends successfully.</h2>
<%
} catch (RQLException ex) {
	out.println("<h2>Error occurred</h2>");
	out.print(ex.getMessage());
	System.err.println(ex.getMessage());
	ex.printStackTrace();
	if (ex.getReason() != null) {
		out.print(ex.getReason().getMessage());
		System.err.println(ex.getReason().getMessage());
		ex.getReason().printStackTrace();
	}
}
%>
<input type="button" value="Close window" onClick="javascript:window.close()">
</div>

</BODY>
</HTML>
