<%@ page import="java.util.*, com.hlcl.rql.as.*" session="false" isThreadSafe="true" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<%
// get variables
ResourceBundle b = ResourceBundle.getBundle("com.hlcl.rql.as.rql_fw");
String cssUrl = b.getString("cssUrl");
%>
<%-- remove server name when migrating to DEVE or PROD --%>
<link href="<%=cssUrl%>" rel="styleSheet" type="text/css">
<TITLE>Cancel waiting jobs</TITLE>
</HEAD>

<BODY>
<%
// get all RedDot session/project values from request
String logonGuid = request.getParameter("logonGuid");
String sessionKey = request.getParameter("sessionKey");
String projectGuid = request.getParameter("projectGuid");
%>	

<!-- page title, mandatory -->
<div class="block">
<table class="pageTitleTable" cellspacing="0" cellpadding="0">
    <tr>
        <td class="pageTitleGrey">Cancel waiting jobs</td>
    </tr>
</table>
</div>

<!-- result or exception block -->
<div class="block">
<P>The following jobs are canceled:</P>
<%
try {
	// open project
	CmsClient client = new CmsClient(logonGuid);
	Project project = client.getProject(sessionKey, projectGuid);
	
	// list all waiting jobs
	JobQueue waitingJobs = project.getWaitingPublishingJobs();
	for (int i = 0; i < waitingJobs.size(); i++) {
		PublishingJob job = (PublishingJob) waitingJobs.get(i);
		out.println(job.getName() + "<br>");
	}
	
	// cancel all
	waitingJobs.cancelAll();
%>
<h2>Cancel waiting jobs ends successfully.</h2>
<%
} catch (RQLException ex) {
	out.println("<h2>Error occurred</h2>");
	out.print(ex.getMessage());
	System.err.println(ex.getMessage());
	ex.printStackTrace();
	if (ex.getReason() != null) {
		out.print(ex.getReason().getMessage());
		System.err.println(ex.getReason().getMessage());
		ex.getReason().printStackTrace();
	}
}
%>
</div>
<form action="">
<input type="button" value="Close window" onClick="window.close()">
</form>
</BODY>
</HTML>
