<%@ page import="java.util.*, com.hlcl.rql.as.*, com.hlcl.rql.util.as.*" session="false" isThreadSafe="true" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<%
// get variables
ResourceBundle b = ResourceBundle.getBundle("com.hlcl.rql.as.rql_fw");
String cssUrl = b.getString("cssUrl");
String refreshAsp = b.getString("refreshAsp");
%>
<%-- remove server name when migrating to DEVE or PROD --%>
<link href="<%=cssUrl%>" rel="styleSheet" type="text/css">
<TITLE>Reset all draft pages</TITLE>
</HEAD>

<BODY>
<%
// get all RedDot  values from request
String logonGuid = request.getParameter("logonGuid");
String sessionKey = request.getParameter("sessionKey");
String projectGuid = request.getParameter("projectGuid");
%>	

<!-- page title, mandatory -->
<div class="block">
<table class="pageTitleTable" cellspacing="0" cellpadding="0">
    <tr>
        <td class="pageTitleGrey">Reset all draft pages</td>
    </tr>
</table>
</div>

<!-- result or exception block -->
<div class="block">
<%
try {
	// open project
	CmsClient client = new CmsClient (logonGuid);
	Project project = client.getProject(sessionKey, projectGuid);
	User connectedUser = client.getConnectedUser();

	// delete of undo changed for all draft pages
	PageArrayList draftPages = connectedUser.getPagesSavedAsDraft(project);
	int deleted = 0;
	int undo = 0;
	int left = 0;
%>
There are <%=draftPages.size()%> draft pages.<br>
<%
	for (int i = 0; i < draftPages.size(); i++) {
		Page draftPg = (Page) draftPages.get(i);
		boolean isChanged = draftPg.isInStateSavedAsDraftChanged();
		boolean isNew = draftPg.isInStateSavedAsDraftNew();
		String headline = draftPg.getHeadlineAndId();
		
		// delete or undo
		try {
			draftPg.resetDraftState();
			if (isChanged) {
				out.print("undo&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
				undo += 1;
			}
			if (isNew) {
				out.print("delete&nbsp;&nbsp;&nbsp;&nbsp;");
				deleted += 1;
			}
		} catch (MissingRightException mre) {
			out.print("no right&nbsp;");
			left += 1;
		}
		out.println(headline +"<br />");
		out.flush();
	}
%>
<br />
The script had deleted <%=deleted%> pages and made changes on <%=undo%> pages unhappen.<br />
There are still <%=left%> pages in draft.<br />
<h2>Reset all draft pages ends successfully.</h2>
<%
} catch (RQLException ex) {
	out.println("<h2>Error occurred</h2>");
	out.print(ex.getMessage());
	System.err.println(ex.getMessage());
	ex.printStackTrace();
	if (ex.getReason() != null) {
		out.print(ex.getReason().getMessage());
		System.err.println(ex.getReason().getMessage());
		ex.getReason().printStackTrace();
	}
}
%>
<form action="<%=refreshAsp%>" method="GET">
<br><input type="submit" value="Close window and Refresh" >
</form>
</div>
</BODY>
</HTML>
